/*
 *  BDrawingModeWnd.h
 *  MoG2Editor
 *
 *  Created by Santi Ontan Mon Jun 02 2003.
 *
 */

#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif

#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "tiles.h"

#include "BWindow.h"
#include "BFileListWnd.h"
#include "BActiveWindow.h"
#include "BDrawingModeWnd.h"

#include "BIntegerEdDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BDrawingModeWnd::BDrawingModeWnd(int x,int y,int dx,int dy,OBJECT *o,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_dx;
        
    but_dx=get_text_width("DRAWING MODE",font)+10;
	b=new BButton(20,20,but_dx,12,"DRAWING MODE",3);
	buttons.Add(b);

	but_dx=get_text_width("ACCEPT",font)+10;
	b=new BButton(20,dy-20,but_dx,12,"ACCEPT",1);
	buttons.Add(b);

	but_dx=get_text_width("CANCEL",font)+10;
	b=new BButton(120,dy-20,but_dx,12,"CANCEL",2);
	buttons.Add(b);

	object=o;
    
    drawing_mode=object->dm_drawing_mode;
    factor=object->dm_factor;
    color1_r=object->dm_color1_r;
    color1_g=object->dm_color1_g;
    color1_b=object->dm_color1_b;
    color1_a=object->dm_color1_a;
    color2_r=object->dm_color2_r;
    color2_g=object->dm_color2_g;
    color2_b=object->dm_color2_b;
    color2_a=object->dm_color2_a;

	scale=object->scale;
	angle=object->angle;

} /* BDrawingModeWnd::BDrawingModeWnd */ 


BDrawingModeWnd::~BDrawingModeWnd()
{

} /* BDrawingModeWnd::BDrawingModeWnd */ 


void BDrawingModeWnd::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BDrawingModeWnd::contens_size */ 


bool BDrawingModeWnd::cycle(int stx,int sty)
{
        int x,y;
        
        if (!BActiveWindow::cycle(stx,sty)) return false;
        
        if (((mouse_button&SDL_BUTTON(1) &&
	    !(old_mouse_button&SDL_BUTTON(1))) ||
            (mouse_button&SDL_BUTTON(3) &&
	    !(old_mouse_button&SDL_BUTTON(3)))) &&
	    local_mouse_x>=old_stx && 
	    local_mouse_y>=old_sty &&
	    local_mouse_x<old_endx &&
	    local_mouse_y<old_endy) {
            
            x=mouse_x-70;
            y=mouse_y;
            if (y>(old_y+old_dy-60)) y=old_y+old_dy-60;
            if (x>(old_x+old_dx-140)) x=old_x+old_dx-140;
            if (x<0) x=0;
                                
            if (local_mouse_x>=70 && local_mouse_x<100 &&
                local_mouse_y>=40 && local_mouse_y<40+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter factor value:",&factor,3,font);
				dlg->Execute();
				delete dlg;
                
                if (factor<0) factor=0;
                if (factor>100) factor=100;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=50 && local_mouse_x<80 &&
                local_mouse_y>=70 && local_mouse_y<70+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Red value:",&color1_r,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color1_r<-1) color1_r=-1;
                if (color1_r>255) color1_r=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=50 && local_mouse_x<80 &&
                local_mouse_y>=80 && local_mouse_y<80+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Green value:",&color1_g,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color1_g<-1) color1_g=-1;
                if (color1_g>255) color1_g=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=50 && local_mouse_x<80 &&
                local_mouse_y>=90 && local_mouse_y<90+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Blue value:",&color1_b,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color1_b<-1) color1_b=-1;
                if (color1_b>255) color1_b=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=50 && local_mouse_x<80 &&
                local_mouse_y>=100 && local_mouse_y<100+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Alpha value:",&color1_a,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color1_a<-1) color1_a=-1;
                if (color1_a>255) color1_a=255;
                set_dirty();
            } /* if */ 
            
            if (local_mouse_x>=120 && local_mouse_x<150 &&
                local_mouse_y>=70 && local_mouse_y<70+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Red value:",&color2_r,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color2_r<-1) color2_r=-1;
                if (color2_r>255) color2_r=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=120 && local_mouse_x<150 &&
                local_mouse_y>=80 && local_mouse_y<80+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Green value:",&color2_g,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color2_g<-1) color2_g=-1;
                if (color2_g>255) color2_g=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=120 && local_mouse_x<150 &&
                local_mouse_y>=90 && local_mouse_y<90+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Blue value:",&color2_b,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color2_b<-1) color2_b=-1;
                if (color2_b>255) color2_b=255;
                set_dirty();
            } /* if */ 
            if (local_mouse_x>=120 && local_mouse_x<150 &&
                local_mouse_y>=100 && local_mouse_y<100+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Alpha value:",&color2_a,3,font);
				dlg->Execute();
				delete dlg;
                
                if (color2_a<-1) color2_a=-1;
                if (color2_a>255) color2_a=255;
                set_dirty();
            } /* if */ 

            if (local_mouse_x>=80 && local_mouse_x<110 &&
                local_mouse_y>=120 && local_mouse_y<120+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Scale value:",&scale,4,font);
				dlg->Execute();
				delete dlg;
                
                if (scale<0) scale=0;
                if (scale>6400) scale=6400;
                set_dirty();
            } /* if */ 

            if (local_mouse_x>=80 && local_mouse_x<110 &&
                local_mouse_y>=130 && local_mouse_y<130+TTF_FontHeight(font)) {
                BIntegerEdDlg *dlg;
				dlg=new BIntegerEdDlg(x,y,140,60,"Enter Angle value:",&angle,3,font);
				dlg->Execute();
				delete dlg;
                
				while(angle<0) angle+=360;
				while(angle>=360) angle-=360;
                set_dirty();
            } /* if */ 

        } /* if */ 
        return true;
} /* BDrawingModeWnd::cycle */ 


void BDrawingModeWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
        SDL_Rect r;
        char tmp[8];

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);
        
        switch(drawing_mode) {
	case 0:print_left("NORMAL",font,255,255,255,sfc,120-stx,22-sty);
               break;
	case 1:print_left("SHADED",font,255,255,255,sfc,120-stx,22-sty);
               break;
	case 2:print_left("BICOLOR",font,255,255,255,sfc,120-stx,22-sty);
               break;
	case 3:print_left("REFLECT",font,255,255,255,sfc,120-stx,22-sty);
               break;
	case 4:print_left("REFRACT",font,255,255,255,sfc,120-stx,22-sty);
               break;
	} /* switch */ 

		print_left("FACTOR:",font,255,255,255,sfc,20-stx,40-sty);
        sprintf(tmp,"%i",factor);
		print_left(tmp,font,255,255,255,sfc,70-stx,40-sty);

		print_left("COLOR 1:",font,255,255,255,sfc,20-stx,60-sty);
		print_left("R",font,255,255,255,sfc,20-stx,70-sty);
        sprintf(tmp,"%i",color1_r);
		print_left(tmp,font,255,255,255,sfc,50-stx,70-sty);
		print_left("G",font,255,255,255,sfc,20-stx,80-sty);
        sprintf(tmp,"%i",color1_g);
		print_left(tmp,font,255,255,255,sfc,50-stx,80-sty);
		print_left("B",font,255,255,255,sfc,20-stx,90-sty);
        sprintf(tmp,"%i",color1_b);
		print_left(tmp,font,255,255,255,sfc,50-stx,90-sty);
		print_left("A",font,255,255,255,sfc,20-stx,100-sty);
        sprintf(tmp,"%i",color1_a);
		print_left(tmp,font,255,255,255,sfc,50-stx,100-sty);

		print_left("COLOR 2:",font,255,255,255,sfc,120-stx,60-sty);
		print_left("R",font,255,255,255,sfc,120-stx,70-sty);
        sprintf(tmp,"%i",color2_r);
		print_left(tmp,font,255,255,255,sfc,150-stx,70-sty);
		print_left("G",font,255,255,255,sfc,120-stx,80-sty);
        sprintf(tmp,"%i",color2_g);
		print_left(tmp,font,255,255,255,sfc,150-stx,80-sty);
		print_left("B",font,255,255,255,sfc,120-stx,90-sty);
        sprintf(tmp,"%i",color2_b);
		print_left(tmp,font,255,255,255,sfc,150-stx,90-sty);
		print_left("A",font,255,255,255,sfc,120-stx,100-sty);
        sprintf(tmp,"%i",color2_a);
		print_left(tmp,font,255,255,255,sfc,150-stx,100-sty);

		print_left("SCALE",font,255,255,255,sfc,20-stx,120-sty);
        sprintf(tmp,"%i",scale);
		print_left(tmp,font,255,255,255,sfc,80-stx,120-sty);
		print_left("ANGLE",font,255,255,255,sfc,20-stx,130-sty);
        sprintf(tmp,"%i",angle);
		print_left(tmp,font,255,255,255,sfc,80-stx,130-sty);
} /* BDrawingModeWnd::BDrawingModeWnd */ 


bool BDrawingModeWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
        object->dm_drawing_mode=drawing_mode;
        object->dm_factor=factor;
        object->dm_color1_r=color1_r;
        object->dm_color1_g=color1_g;
        object->dm_color1_b=color1_b;
        object->dm_color1_a=color1_a;
        object->dm_color2_r=color2_r;
        object->dm_color2_g=color2_g;
        object->dm_color2_b=color2_b;
        object->dm_color2_a=color2_a;
		object->scale=scale;
		object->angle=angle;
		return false;
		break;

	case 2:
		return false;
		break;
                
        case 3: switch(drawing_mode) {
                case 0:drawing_mode=1;
                       break;
                case 1:drawing_mode=2;
                       break;
                case 2:drawing_mode=3;
                       break;        
				case 3:drawing_mode=4;
					   break;
				case 4:drawing_mode=0;
					   break;
                } /* switch */ 
                set_dirty();
                return true;
                break;

	} /* switch */ 

	return false;
} /* BDrawingModeWnd::BDrawingModeWnd */ 

