#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif

#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "VariableListWnd.h"
#include "VariableSelectorWnd.h"

#include "valuescript.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BVariableSelectorWnd::BVariableSelectorWnd(int x,int y,int dx,int dy,EDITOR *e,OBJECT *o,ROOM *r,MAP *m,MOG2 *g,MOG2_INTERFACE *interf,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int bx=20;
	int but_dx;

	but_dx=get_text_width("ACCEPT",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"ACCEPT",1);
	buttons.Add(b);
	bx+=but_dx+20;

	but_dx=get_text_width("CANCEL",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"CANCEL",2);
	buttons.Add(b);
	bx+=but_dx+20;


	but_dx=get_text_width("OBJECT",font)+10;
	b=new BButton(5,5,but_dx,12,"OBJECT",10);
	buttons.Add(b);

	but_dx=get_text_width("ROOM",font)+10;
	b=new BButton(5,25,but_dx,12,"ROOM",11);
	buttons.Add(b);

	but_dx=get_text_width("MAP",font)+10;
	b=new BButton(5,45,but_dx,12,"MAP",12);
	buttons.Add(b);

	but_dx=get_text_width("GAME",font)+10;
	b=new BButton(5,65,but_dx,12,"GAME",13);
	buttons.Add(b);

	but_dx=get_text_width("INTERFACE",font)+10;
	b=new BButton(5,85,but_dx,12,"INTERFACE",14);
	buttons.Add(b);

	but_dx=get_text_width("FOREIGN",font)+10;
	b=new BButton(5,105,but_dx,12,"FOREIGN",15);
	buttons.Add(b);

	but_dx=get_text_width("APPLICATION",font)+10;
	b=new BButton(5,125,but_dx,12,"APPLICATION",16);
	buttons.Add(b);

	editor=e;

	vlw=new VariableListWnd(85,10,dx-95,dy-60,editor,o,r,m,g,interf,font);

} /* BVariableSelectorWnd::BVariableSelectorWnd */ 


BVariableSelectorWnd::~BVariableSelectorWnd()
{
	delete vlw;

} /* BVariableSelectorWnd::BVariableSelectorWnd */ 


void BVariableSelectorWnd::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BVariableSelectorWnd::contens_size */ 



bool BVariableSelectorWnd::cycle(int stx,int sty)
{
	if (!BActiveWindow::cycle(stx,sty)) return false;

	vlw->cycle(stx+85,sty+10);
	if (vlw->is_dirty()) set_dirty();

	return true;
} /* BVariableSelectorWnd::cycle */ 



void BVariableSelectorWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	r.x=85-stx;
	r.y=10-sty;
	r.w=dx-95;
	r.h=dy-60;
	SDL_FillRect(sfc,&r,0x00000000);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	vlw->draw(sfc,85-stx,10-sty,dx-95,dy-60);

} /* BVariableSelectorWnd::draw_contens */ 


bool BVariableSelectorWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		return false;
		break;

	case 2:
		vlw->selected=0;
		return false;
		break;

	case 10:
		vlw->scope_to_refind=VALUE_VAR_OBJECT;
		return true;
		break;
	case 11:
		vlw->scope_to_refind=VALUE_VAR_ROOM;
		return true;
		break;
	case 12:
		vlw->scope_to_refind=VALUE_VAR_MAP;
		return true;
		break;
	case 13:
		vlw->scope_to_refind=VALUE_VAR_GAME;
		return true;
		break;
	case 14:
		vlw->scope_to_refind=VALUE_VAR_INTERFACE;
		return true;
	case 15:
		vlw->scope_to_refind=VALUE_VAR_FOREIGN;
		return true;
		break;
	case 16:
		vlw->scope_to_refind=VALUE_VAR_APPLICATION;
		return true;
	} /* switch */ 

	return false;
} /* BVariableSelectorWnd::button_pressed */ 

